<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:f="http://xmlns.jcp.org/jsf/core"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:p="http://primefaces.org/ui">
    <h:body> 
        <h2>#{msgs.editBook}</h2>
        <h:form id="EditBook">
            <p:growl id="growl" showDetail="true"/>
            <p:dataTable value="#{inventoryBackingBean.allBooks}"
                         emptyMessage="#{msgs.noBooksFound}"
                         var="books"
                         widgetVar="bookTable"
                         editable="true"
                         paginator="true"
                         paginatorTemplate="{CurrentPageReport} {FirstPageLink} {PreviousPageLink} {PageLinks} {NextPageLink} {LastPageLink} {RowsPerPageDropdown}"
                         currentPageReportTemplate="{startRecord}-{endRecord} of {totalRecords} records"
                         rowsPerPageTemplate="5,10,30,100"
                         rows="10">
                <f:facet name="header">
                    <p:outputPanel>
                        <h:outputText value="#{msgs.search}:  " />
                        <p:inputText id="globalFilter" onkeyup="PF('bookTable').filter()" style="width:350px" placeholder="#{msgs.enterBookisbn} #{msgs.ou} #{msgs.title}"/>
                    </p:outputPanel>
                </f:facet>

                <p:ajax event="rowEdit" listener="#{inventoryBackingBean.onRowEdit}" update=":EditBook:growl" />
                <p:ajax event="rowEditCancel" listener="#{inventoryBackingBean.onRowCancel}" update=":EditBook:growl" />

                <p:column headerText="#{msgs.edit}" style="width:50px">
                    <p:rowEditor/>                        
                </p:column>
                <p:column filterBy="#{books.title}" filterMatchMode="contains" filterStyle="display:none;" colspan="2" headerText="#{msgs.title}">
                    <p:cellEditor>
                        <f:facet name="output"><h:outputText value="#{books.title}" /></f:facet>
                        <f:facet name="input">
                            <p:inputText id="title" value="#{books.title}" 
                                         required="true" style="width:100%;color: black;;color: black;"
                                         requiredMessage="#{msgs.title} #{msgs.is} #{msgs.required}">
                                <f:validateLength minimum="2" maximum="200" />
                            </p:inputText>
                            <p:message for="title"/>
                        </f:facet>
                    </p:cellEditor>
                </p:column>
                <p:column filterBy="#{books.isbn}" filterMatchMode="contains" filterStyle="display:none;" colspan="2" headerText="#{msgs.author}">
                    <p:cellEditor>
                        <f:facet name="output"><h:outputText value="#{books.authorId.name}" /></f:facet>
                        <f:facet name="input">
                            <p:inputText id="author" value="#{books.authorId.name}" 
                                         required="true" style="width:100%;color: black;;color: black;"
                                         requiredMessage="#{msgs.author} #{msgs.is} #{msgs.required}">
                                <f:validateLength minimum="2" maximum="100" />
                            </p:inputText>
                            <p:message for="author"/>
                        </f:facet>
                    </p:cellEditor>
                </p:column>
                <p:column colspan="2" headerText="#{msgs.publisher}">
                    <p:cellEditor>
                        <f:facet name="output"><h:outputText value="#{books.publisherId.name}" /></f:facet>
                        <f:facet name="input">
                            <p:inputText id="publisher" value="#{books.publisherId.name}" 
                                         required="true" style="width:100%;color: black;;color: black;"
                                         requiredMessage="#{msgs.publisher} #{msgs.is} #{msgs.required}">
                                <f:validateLength minimum="2" maximum="45" />
                            </p:inputText>
                            <p:message for="publisher"/>
                        </f:facet>
                    </p:cellEditor>
                </p:column>
                <p:column colspan="2" headerText="#{msgs.datePublication}">
                    <p:cellEditor>
                        <f:facet name="output">
                            <h:outputText value="#{books.dataPublication}">
                                <f:convertDateTime pattern="yyyy-MM-dd"/>
                            </h:outputText>
                        </f:facet>
                        <f:facet name="input">
                            <h:inputText id="date" value="#{books.dataPublication}" 
                                         style="width:100%;color: black;;color: black;" required="true"
                                         requiredMessage="#{msgs.datePublication} #{msgs.is} #{msgs.required}">
                                <f:convertDateTime pattern="yyyy-MM-dd"/>
                            </h:inputText>
                            <p:message for="date"/>
                        </f:facet>
                    </p:cellEditor>
                </p:column>
                <p:column headerText="#{msgs.numOfPages}">
                    <p:cellEditor>
                        <f:facet name="output"><h:outputText value="#{books.numberOfPages}" /></f:facet>
                        <f:facet name="input"><p:inputText id="pages" value="#{books.numberOfPages}" required="true"
                                                           requiredMessage="#{msgs.numOfPages} #{msgs.is} #{msgs.required}">
                                <f:validateDoubleRange minimum="2" maximum="100000" />
                            </p:inputText>
                            <p:message for="pages"/>
                        </f:facet>
                    </p:cellEditor>
                </p:column>
                <p:column colspan="3" headerText="#{msgs.description}">
                    <p:cellEditor>
                        <f:facet name="output"><h:inputTextarea cols="27" rows="3" readonly="true" value="#{books.description}" /></f:facet>
                        <f:facet name="input">
                            <p:inputTextarea id="desc" cols="30" rows="7" autoResize="true" value="#{books.description}" style="width:100%;color: black;"
                                             required="true" requiredMessage="#{msgs.description} #{msgs.is} #{msgs.required}">
                                <f:validateLength minimum="10" maximum="3000"/>
                            </p:inputTextarea>
                            <p:message for="desc"/>
                        </f:facet>
                    </p:cellEditor>
                </p:column>
                <p:column headerText="#{msgs.wholePrice}">
                    <p:cellEditor>
                        <f:facet name="output"><h:outputText value="#{books.wholesalePrice}" /></f:facet>
                        <f:facet name="input">
                            <p:inputText id="wprice" value="#{books.wholesalePrice}" required="true"
                                         requiredMessage="#{msgs.wholePrice} #{msgs.is} #{msgs.required}">
                                <f:validateDoubleRange minimum="1.0" maximum="999.99"/>
                            </p:inputText>
                            <p:message for="wprice"/>
                        </f:facet>
                    </p:cellEditor>
                </p:column>
                <p:column headerText="#{msgs.listPrice}">
                    <p:cellEditor>
                        <f:facet name="output"><h:outputText value="#{books.listPrice}" /></f:facet>
                        <f:facet name="input">
                            <p:inputText id="lprice" value="#{books.listPrice}" styleClass="form-control" required="true"
                                         requiredMessage="#{msgs.listPrice} #{msgs.is} #{msgs.required}" 
                                         validator="#{inventoryBackingBean.validateWholeAndListPriceDecimal}">
                                <f:validateDoubleRange minimum="1.0" maximum="999.99" />
                            </p:inputText>
                            <p:message for="lprice"/>
                        </f:facet>
                    </p:cellEditor>
                </p:column>
<!--                <p:column headerText="#{msgs.totalSales}">
                    <p:cellEditor>
                        <f:facet name="output"><h:outputText value="#{books.discount}" /></f:facet>
                        <f:facet name="input">
                            <p:inputText readonly="true" id="discount" value="#{books.discount}" styleClass="form-control" required="true"
                                         requiredMessage="#{msgs.discount} #{msgs.is} #{msgs.required}">
                                <f:validateDoubleRange minimum="0" maximum="99" />
                            </p:inputText>
                            <p:message for="discount"/>
                        </f:facet>
                    </p:cellEditor>
                </p:column>-->
                <p:column headerText="#{msgs.removalStatus}">
                    <p:cellEditor>
                        <f:facet name="output"><p:selectBooleanButton disabled="true" onLabel="#{books.removalStatus? 'removed': 'available'}" offLabel="#{books.removalStatus? 'removed': 'available'}" style="width:100%;color: black;font-size: 12px;"/></f:facet>
                        <f:facet name="input"><p:selectBooleanButton value="#{books.removalStatus}" onLabel="#{!books.removalStatus? 'add': 'remove'}" offLabel="#{books.removalStatus? 'add': 'remove'}" style="width:100%;color: black;font-size: 12px;"/></f:facet>
                    </p:cellEditor>
                </p:column>
            </p:dataTable>
        </h:form>
    </h:body>
</html>


